<?php

class UaKinoNet_Category extends UaKinoNet implements UserInputHandler
{

    const ID = 'UaKinoNet_Category_ID';

    function handle_user_input(&$user_input, &$plugin_cookies)
    {
        hd_print("UaKinoNet_Category::handle_user_input");
    }

    /**
     *
     * @return type 
     */
    function get_handler_id()
    {
        return self::ID;
    }

    /**
     *
     * @return type 
     */
    function favorites($conf_path)
    {
        $favorites = array();

        foreach (get_object_vars(FavoritesList::get()) as $key => $value)
        {
            if (isset($value->title))
            {
                $item = array('title' => $value->title, 'media_url' => $value->media_url, 'image' => $value->poster);
                array_push($favorites, $item);
            }
        }

        $favorites = array_reverse($favorites);

        $remove = UserInputHandlerRegistry::create_action($this, 'remove_fav');
        $remove['caption'] = 'Удалить с избранного';

        $menu_items[] = array(
            GuiMenuItemDef::caption => $remove['caption'],
            GuiMenuItemDef::action => $remove
        );
        $popup_search_action = ActionFactory::show_popup_menu($menu_items);
        
        
        $actions = array
            (
            GUI_EVENT_KEY_ENTER => array(GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID),
            GUI_EVENT_KEY_C_YELLOW => $remove,
            GUI_EVENT_KEY_POPUP_MENU => $popup_search_action,
        );

        $items = array();

        foreach ($favorites as $item)
        {
            array_push
                    (
                    $items, array
                (
                PluginRegularFolderItem::caption => $item['title'],
                PluginRegularFolderItem::starred => true,
                PluginRegularFolderItem::view_item_params => array
                    (
                    ViewItemParams::icon_path => $item['image'],
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_sel_scale_factor => 1.28,
                    ViewItemParams::icon_sel_margin_left => 2,
                    ViewItemParams::icon_sel_margin_top => 0,
                    ViewItemParams::icon_margin_right => 15,
                    ViewItemParams::item_paint_caption_within_icon => false,
                    ViewItemParams::item_paint_caption => false,
                ),
                PluginRegularFolderItem::media_url => $item['media_url']
                    )
            );
        }

        return DuneLists::build_img_list($items, $actions);
    }

    function index($confing_path, $video_id = 0)
    {
        echo '<p>UaKinoNet_Category -> index</p>';

        $video_category_id = 837;
        $url = Rise::$config->load('uakinonet.categories.video.link') . $video_category_id;

        $content = file_get_contents($url);

        /*$pattern = '{[^<strong>]<a.*?href="((?:category/)?video/[0-9]+)"\s+class="preview".*?>.*?<img.*?src="(.*?)".*?</a>.*?<strong>.*?<a.*?href=".*?".*?title="(.*?)">(.*?)</a>}is';
        */
		$pattern = '{ <div class="media_line_item.*?<a href="((?:category/)?video/[0-9]+)".*?class="fleft thumb"><img src="(.*?)".*?</a>.*?<a.*?href=".*?".*?title="(.*?)">(.*?)</a>}is';
		$count = preg_match_all($pattern, $content, $matches);
        $videos = array();
        if ($count)
        {
            for ($i = 0; $i < $count; $i++)
            {
                $videos[] = array(
                    'link' => $matches[1][$i],
                    'image' => $matches[2][$i],
                    'alt' => $matches[3][$i],
                    'title' => $matches[4][$i],
                );
            }
            echo '<pre>';
            print_r($videos);
        }
        else
            echo 'No matches found';
    }

    public function getLoadingItems()
    {
        $items = array($this->getLoadingItemArr());

        return array(
            PluginRegularFolderRange::total => count($items),
            PluginRegularFolderRange::count => count($items),
            PluginRegularFolderRange::more_items_available => true,
            PluginRegularFolderRange::from_ndx => 0,
            PluginRegularFolderRange::items => $items
        );
    }

    public function getLoadingItemArr()
    {
        return array
            (
            PluginRegularFolderItem::caption => 'Загрузка...',
            PluginRegularFolderItem::view_item_params => array
                (
                ViewItemParams::item_paint_icon => false,
                ViewItemParams::icon_path => 'gui_skin://large_icons/movie.aai',
                ViewItemParams::item_layout => HALIGN_LEFT,
                ViewItemParams::icon_valign => VALIGN_CENTER,
                ViewItemParams::item_detailed_icon_path => 'missing://',
            ),
            PluginRegularFolderItem::media_url => 'dummy'
        );
    }

    /**
     *
     * @param type $input
     * @return type 
     */
    function input(&$input)
    {
        hd_print("UaKinoNet_Category::input = " . json_encode($input));

        if (isset($input->control_id))
        {
            $control_id = $input->control_id;
            switch ($control_id)
            {
                case "remove_fav":
                    if (isset($input->video_id))
                    {
                        FavoritesList::delete('fav_video' . $input->video_id);
                    } else
                    {
                        preg_match('/.*?\/(\d*)/', $input->selected_media_url, $matches);

                        FavoritesList::delete('fav_video' . $matches[1]);
                    }
                    return ActionFactory::invalidate_folders(array($input->parent_media_url), UserInputHandlerRegistry::create_action($this, 'del_fav_complite'));
                case "add_to_fav":

                    if (!isset($input->video_id))
                    {
                        preg_match('/.*?\/(\d*)/', $input->selected_media_url, $matches);
                        $input->video_id = $matches[1];
                    }

                    $data = $this->getVideoInfo($input->video_id);

                    FavoritesList::set('fav_video' . $input->video_id, array('poster' => $data['image'], 'media_url' => get_class($this) . '->details/' . $input->video_id, 'title' => $data['title']));

                    return ActionFactory::invalidate_folders(array($input->parent_media_url), UserInputHandlerRegistry::create_action($this, 'add_fav_complite'));
                case 'add_fav_complite':
                    return ActionFactory::show_title_dialog('Видео добавлено в избранное');
                case 'del_fav_complite':
                    return ActionFactory::show_title_dialog('Видео было удалено из избранного');
                case 'add_to_templates':
                    preg_match('/.*?\/(\S*)\//', $input->selected_media_url, $matches);

                    hd_print('add_to_templates  = ' . $matches[1]);
                    $n = Cookie::get('templ_count', 0);
                    Cookie::set('templ_count', ++$n);
                    Cookie::set('templ_video_search_text' . $n, urldecode($matches[1]));

                    return ActionFactory::invalidate_folders(array($input->parent_media_url), UserInputHandlerRegistry::create_action($this, 'add_templ_complite'));
                case 'add_templ_complite':
                    return ActionFactory::show_title_dialog('Шаблон для поиска был добавлен');
                case 'remove_search':
                    preg_match('/.*?\/.*?\/(\d*)/', $input->selected_media_url, $matches);
                    hd_print('Cookie::delete(search_text = ' . $matches[1]);
                    Cookie::delete('search_text' . $matches[1]);

                    return ActionFactory::invalidate_folders(array($input->parent_media_url), UserInputHandlerRegistry::create_action($this, 'del_search_complite'));
                case 'del_search_complite':
                    return ActionFactory::show_title_dialog('Запрос поиска был успешно удалён');
                case 'remove_template':
                    preg_match('/.*?\/.*?\/(\d*)/', $input->selected_media_url, $matches);
                    hd_print('Cookie::delete(search_text = ' . $matches[1]);
                    Cookie::delete('templ_video_search_text' . $matches[1]);

                    return ActionFactory::invalidate_folders(array($input->parent_media_url), UserInputHandlerRegistry::create_action($this, 'del_template_complite'));
                case 'del_template_complite':
                    return ActionFactory::show_title_dialog('Шаблон поиска был успешно удалён');
            }
        }
    }

    /**
     *
     * @param type $video_id
     * @return boolean 
     */
    function getVideoInfo($video_id)
    {
        $currnet_confing_path = Cookie::get('currnet_confing_path');

        hd_print("UaKinoNet_Category_Video::getVideoInfo \$currnet_confing_path = $currnet_confing_path");

        $v = Rise::$config->load($currnet_confing_path . '.details_link');
        $detail_link = empty($v) ? Rise::$config->load('uakinonet.default_detail_link') : $v;

        $url = $this->video_details_url = 'http://' . Rise::$config->load('uakinonet.host') . $detail_link . $video_id;

        hd_print('UaKinoNet_Category_Video->getVideoInfo url= ' . $url);
        try
        {
            $content = file_get_contents($url);
//            hd_print($content);
        } catch (Exception $e)
        {
            hd_print($e->getMessage());
        }

     //   preg_match_all('{var flvfile = "(.*?)".*?poster: "(.*?)"}si', $content, $m_file);
		preg_match('{var flvfile = \'(.*?)\';}si', $content, $m_file);
		preg_match('{poster: "(.*?)"}si', $content, $p_file);
		preg_match('{ролях:</span>(.*?)</li>}si', $content, $m_actors);        
        preg_match('{Название:</span>(.*?)</li>}si', $content, $m_title1);
        preg_match('{Год выхода:</span>(.*?)</li>}si', $content, $m_year);
        preg_match('{Жанр:</span>(.*?)</li>}si', $content, $m_genre);
        preg_match('{<div id="media_description">(.*?)</span>}si', $content, $m_descr);
        preg_match('{Страна:</span>(.*?)</li>}si', $content, $m_country);
        preg_match('{Режиссер:</span>(.*?)</li>}si', $content, $m_directors);
        preg_match_all('{<span>Оригинальное название:</span>(.*?)</i>}si', $content, $m_title_native);
        
        if (isset($m_file[1][0]))
        {
            $videoInfo = array(
                'id' => $video_id,
                'title' => trim(strip_tags($m_title1[1])) . ' / '. trim(strip_tags($m_title_native[1][0])),
                'image' => trim(strip_tags($p_file[1])),
                'genre' => trim(strip_tags($m_genre[1])),
                'year' => trim(strip_tags($m_year[1])),
                'country' => trim(strip_tags($m_country[1])),
                'directors' => trim(strip_tags($m_directors[1])),
                'actors' => trim(strip_tags($m_actors[1])),
                'description' => trim(strip_tags($m_descr[1])),
                'file' => 'http://uakino.net/play.php?mid=' . $video_id .'.mp4',
            );
        } else
        {
            hd_print('No video info found');

            $videoInfo = array(
                'id' => $video_id,
                'title' => '',
                'image' => '',
                'genre' => '',
                'year' => '',
                'country' => '',
                'actors' => '',
                'description' => '',
                'file' => '',
            );
        }
        $this->video = $videoInfo;
        return $videoInfo;
    }

    /**
     *
     * @param type $video_id
     * @return null 
     */
    function details($video_id)
    {
        hd_print("\$video_id = $video_id");

        $movie = $this->getVideoInfo($video_id);

        $is_fav = FavoritesList::get('fav_video' . $video_id);
        hd_print("\$is_fav = " . json_encode($is_fav));

        $right_button_caption = $is_fav ? 'Удалить с избранного' : 'Добавить в избранное';
        $right_button_action = $is_fav ? 'remove_fav' : 'add_to_fav';

        $movie_folder_view = array(
            PluginMovieFolderView::movie => array(
                PluginMovie::name => $movie['title'],
                PluginMovie::name_original => '', //$movie['name_original'],
                PluginMovie::description => $movie['description'],
                PluginMovie::poster_url => $movie['image'],
                //PluginMovie::length_min => 1000,
                PluginMovie::year => $movie['year'],
                PluginMovie::directors_str => $movie['directors'],
                //PluginMovie::scenarios_str => '....',
                PluginMovie::actors_str => $movie['actors'],
                PluginMovie::genres_str => $movie['genre'],
                PluginMovie::rate_imdb => '',
                PluginMovie::rate_kinopoisk => '',
                PluginMovie::rate_mpaa => '',
                PluginMovie::country => $movie['country'],
                PluginMovie::budget => ''
            ),
            PluginMovieFolderView::has_right_button => true,
            PluginMovieFolderView::right_button_caption => $right_button_caption,
            PluginMovieFolderView::right_button_action => UserInputHandlerRegistry::create_action($this, $right_button_action, array('video_id' => $video_id)),
            PluginMovieFolderView::has_multiple_series => false,
            PluginMovieFolderView::series_media_url => ''
        );

        return array(
            PluginFolderView::multiple_views_supported => false,
            PluginFolderView::archive => null,
            PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_MOVIE,
            PluginFolderView::data => $movie_folder_view,
        );
    }

    /**
     *
     * @return type 
     */
    function history()
    {
        $items = array();

        foreach (get_object_vars(Cookie::$cookie) as $key => $value)
        {
            hd_print($key . '=>' . $value);

            preg_match('/^search_text(\d*)/', $key, $matches);

            if (isset($matches[1]) && !empty($matches[1]))
            {
                array_push($items, array(
                    PluginRegularFolderItem::caption => 'Поиск [' . $matches[1] . ']: ' . $value,
                    PluginRegularFolderItem::view_item_params => array
                        (
                        ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai',
                        ViewItemParams::item_layout => HALIGN_LEFT,
                        ViewItemParams::icon_valign => VALIGN_CENTER,
                        ViewItemParams::icon_dx => 20,
                        ViewItemParams::icon_dy => -5,
                        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                        ViewItemParams::item_caption_width => 1550
                    ),
                    PluginRegularFolderItem::media_url => 'UaKinoNet_Category_Video_Search->seach_result/' . urlencode($value) . '/' . $matches[1]
                        )
                );
            }
        }

        $items = array_reverse($items); // last are first.

        $elements = array
            (
            PluginRegularFolderRange::total => count($items),
            PluginRegularFolderRange::count => count($items),
            PluginRegularFolderRange::more_items_available => false,
            PluginRegularFolderRange::from_ndx => 0,
            PluginRegularFolderRange::items => $items
        );


        return DuneLists::build_text_list($elements, DuneLists::get_search_action_map($this));
    }

    /**
     *
     * @return type 
     */
    function templates()
    {
        $items = array();

        foreach (get_object_vars(Cookie::$cookie) as $key => $value)
        {
            hd_print($key . '=>' . $value);

            preg_match('/^templ_video_search_text(\d*)/', $key, $matches);

            if (isset($matches[1]) && !empty($matches[1]))
            {
                array_push($items, array(
                    PluginRegularFolderItem::caption => 'Шаблон поиска [' . $matches[1] . ']: ' . $value,
                    PluginRegularFolderItem::view_item_params => array
                        (
                        ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai',
                        ViewItemParams::item_layout => HALIGN_LEFT,
                        ViewItemParams::icon_valign => VALIGN_CENTER,
                        ViewItemParams::icon_dx => 20,
                        ViewItemParams::icon_dy => -5,
                        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                        ViewItemParams::item_caption_width => 1550
                    ),
                    PluginRegularFolderItem::media_url => 'UaKinoNet_Category_Video_Search->seach_result/' . urlencode($value) . '/' . $matches[1]
                        )
                );
            }
        }

        $items = array_reverse($items); // last are first.

        $elements = array
            (
            PluginRegularFolderRange::total => count($items),
            PluginRegularFolderRange::count => count($items),
            PluginRegularFolderRange::more_items_available => false,
            PluginRegularFolderRange::from_ndx => 0,
            PluginRegularFolderRange::items => $items
        );


        return DuneLists::build_text_list($elements, DuneLists::get_templates_action_map($this));
    }

}

?>
