<?php

class UaKinoNet_Category_Video extends UaKinoNet_Category
{

    public $page = 0;
    protected $playVideoFile = null;
    protected $video_details_url = '';
    protected static $vod_play_action = array
        (
        GuiAction::handler_string_id => PLUGIN_VOD_PLAY_ACTION_ID,
        GuiAction::caption => 'Play'
    );
    protected static $folder_open_action = array
        (
        GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
        GuiAction::caption => 'Play'
    );
    public $data;
    protected $currnet_confing_path; // category.unit_name

    function __construct()
    {
        parent::__construct();

        hd_print('UaKinoNet_Category_Video::__construct()');
    }

    /**
     *
     * @param type $confing_path
     * @param type $video_id
     * @return type 
     */
    public function index($confing_path, $video_id = 0)
    {
        $this->currnet_confing_path = $confing_path;
        Cookie::set('currnet_confing_path', $this->currnet_confing_path);
        $style = Cookie::get('current_list_style', 'image');

        if ($style != 'image')
        {
            $items = Screen::build_category($this->currnet_confing_path . '.childs');
        } else
        {
            $items = Screen::build_category_with_image($this->currnet_confing_path . '.childs');
            
        }

        Cookie::set('currnet_sub_video_id', $video_id); // is serial

        if (count($items) > 0)
        {
            hd_print("UaKinoNet_Category_Video->index show submenu");

            $actions = array
                (
                GUI_EVENT_KEY_ENTER => array
                    (
                    GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                )
            );

            if ($style != 'image')
            {
                return DuneLists::build_category_text_list($items, $actions);
            } 
            else
            {
                
                return DuneLists::build_category_img_list($items, $actions);
            }
        }

        hd_print("UaKinoNet_Category_Video->index show items");
        $this->page = 0;
        $this->data = array(); // for reloading items 


        $style = Cookie::get('current_list_video_style', '0');

        $add_to_fav_action = UserInputHandlerRegistry::create_action($this, 'add_to_fav');
        $add_to_fav_action['caption'] = 'Добавить в избранное';
        
        $actions = array
            (
            GUI_EVENT_KEY_ENTER => self::$folder_open_action,
            GUI_EVENT_KEY_PLAY => self::$folder_open_action,
            GUI_EVENT_KEY_D_BLUE => $add_to_fav_action,
        );

        hd_print("UaKinoNet_Category_Video::index \$style = $style");
        
        switch ($style)
        {
            case 0:
                hd_print("DuneLists::build_text_list_with_reloading");
                return DuneLists::build_text_list_with_reloading($this->getLoadingItems(), $actions);
            case 1:
                hd_print("DuneLists::build_img_with_details_list_with_reloading");
                return DuneLists::build_img_with_details_list_with_reloading($this->getLoadingItems(), $actions);
            case 2:
                hd_print("DuneLists::build_img_list_with_reloading");
                return DuneLists::build_img_list_with_reloading($this->getLoadingItems(), $actions);
            default:
                hd_print("DuneLists::build_text_list_with_reloading");
                return DuneLists::build_text_list_with_reloading($this->getLoadingItems(), $actions);
                
        }
    }

    /**
     *
     * @param type $ndx
     * @return type 
     */
    function indexRegular($ndx = 0)
    {
        hd_print('indexRegular $ndx = ' . $ndx);
        $this->currnet_confing_path = Cookie::get('currnet_confing_path');

        $url = 'http://' . Rise::$config->load('uakinonet.host') . Rise::$config->load($this->currnet_confing_path . '.link');
        hd_print('UaKinoNet_Category_Video_Films::indexRegular $ndx = ' . $ndx);

        //$currnet_item_is_serial =  Cookie::get('currnet_item_is_serial');
        $currnet_sub_video_id = Cookie::get('currnet_sub_video_id');

        hd_print("\$currnet_sub_video_id = $currnet_sub_video_id");

        // if are isset submenus, parsing subitems (seasons)
        if ($currnet_sub_video_id > 0)
        {
            $url = 'http://' . Rise::$config->load('uakinonet.host') . Rise::$config->load('uakinonet.default_category_link') . $currnet_sub_video_id;
            hd_print('UaKinoNet_Category_Video_Films::$currnet_sub_video_url = ' . $url);
        }

        /*$regexp = '{<a href="(\S*?)video/(\d*?)" class="preview"><img src="(.*?)".*?alt="(.*?)"}si';*/
		$regexp = '{<a href="(\S*?)video/(\d*?)" class="fleft thumb"><img src="(.*?)".*?alt="(.*?)"}si';
        return $this->indexParrentRegular($url, $regexp, $ndx);
    }

    /**
     *
     * @param type $url
     * @param type $regexp
     * @param type $ndx
     * @return type 
     */
    function indexParrentRegular($url, $regexp, $ndx = 0)
    {
        hd_print("UaKinoNet_Category_Video->indexParrentRegular");

        if ((int) $ndx > 0)
            --$ndx;

        $moreItemsAvailable = false;

        $videos = $this->getData($url, $regexp, $ndx);


        $items = array();
        $total_num = count($this->data);

        $style = Cookie::get('current_list_video_style', '0');

        hd_print('indexParrentRegular $style = ' . $style);

        if ($videos === FALSE)
        {
            $items [] = $this->getItemNoMore();
        } else
        {
            $moreItemsAvailable = true;
            foreach ($videos as $video)
            {
                $items [] = array
                    (
                    PluginRegularFolderItem::caption => $video['caption'],
                    PluginRegularFolderItem::view_item_params => array
                        (
                        ViewItemParams::item_paint_icon => $style > 0,
                        ViewItemParams::icon_path => $video['image'],
                        ViewItemParams::item_detailed_icon_path => $video['image'],
                        ViewItemParams::item_paint_caption => !$style > 0,
                        ViewItemParams::item_paint_caption_within_icon => false,
                        ViewItemParams::item_layout => HALIGN_LEFT,
                        ViewItemParams::icon_valign => VALIGN_CENTER,
                        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                    ),
                    PluginRegularFolderItem::media_url => $video['serial'] ?
                            get_class($this) . '->index/' . $this->currnet_confing_path . '/' . $video['link'] . '/' :
                            get_class($this) . '->details/' . $video['link'],
                );
            }
            $items [] = $this->getLoadingItemArr();
            $total_num++;
        }

        $regularItems = array
            (
            PluginRegularFolderRange::total => $total_num,
            PluginRegularFolderRange::count => count($items),
            PluginRegularFolderRange::more_items_available => $moreItemsAvailable,
            PluginRegularFolderRange::from_ndx => $ndx,
            PluginRegularFolderRange::items => $items
        );

        return $regularItems;
    }

    /**
     *
     * @param type $link_base64
     * @return type 
     */
    function play($link_base64 = NULL)
    {

        $linkToVideo = base64_decode($link_base64);
        hd_print('UaKinoNet_Category_Video_Films->play url = ' . $linkToVideo);
        $video_url = Url::prepareVideoUrl($linkToVideo);
        hd_print('UaKinoNet_Category_Video_Films->play $video_url = ' . $video_url);

        return array
            (
            PluginVodInfo::name => basename($video_url),
            PluginVodInfo::description => '',
            PluginVodInfo::poster_url => '',
            PluginVodInfo::initial_series_ndx => 0,
            PluginVodInfo::series => array
                (
                array
                    (
                    PluginVodSeriesInfo::name => 'Video',
                    PluginVodSeriesInfo::playback_url => $video_url,
                    PluginVodSeriesInfo::playback_url_is_stream_url => true
                )
            ),
            PluginVodInfo::buffering_ms => BUFFERING_MS,
            PluginVodInfo::ip_address_required => TRUE,
            PluginVodInfo::valid_time_required => FALSE,
        );
    }

    private function fillVideoFiles($video)
    {
        $items [] = array
            (
            PluginRegularFolderItem::caption => $video['file'],
            PluginRegularFolderItem::view_item_params => array(
                ViewItemParams::item_paint_icon => FALSE,
                ViewItemParams::item_layout => HALIGN_LEFT,
                ViewItemParams::icon_valign => VALIGN_CENTER,
                ViewItemParams::item_paint_caption_within_icon => false,
                ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
            ),
            PluginRegularFolderItem::media_url => get_class($this) . '->play/' . base64_encode($video['file'])
        );


        return array
            (
            PluginRegularFolderRange::total => count($items),
            PluginRegularFolderRange::count => count($items),
            PluginRegularFolderRange::more_items_available => false,
            PluginRegularFolderRange::from_ndx => 0,
            PluginRegularFolderRange::items => $items
        );
    }

    /**
     *
     * @param type $url
     * @param type $regexp
     * @param type $ndx
     * @return boolean 
     */
    function getData($url, $regexp, $ndx)
    {
        hd_print('getData $ndx = ' . $ndx);

        if ($ndx < count($this->data))
        {
            return array_slice($this->data, $ndx);
        }

        $videos = $this->getNextData($url, $regexp, $ndx);

        if ($videos === FALSE)
        {
            return FALSE; // no more items;
        }

        foreach ($videos as $v)
        {
            array_push($this->data, $v);
        }
        // if connection was succesed to site.
//        if(count($this->data) > 0)
        $this->page++;

        if ($ndx < count($this->data))
            return array_slice($this->data, $ndx);

        return array();
    }

    /**
     *
     * @param string $url
     * @param type $regexp
     * @param type $ndx
     * @return type 
     */
    function getNextData($url, $regexp, $ndx)
    {
        if (strpos($url, '?') === false)
        {
            $url .= '?order=date&offset=' . ($this->page * 16);
        } else
        {
            $url .= '&offset=' . ($this->page * 16);
        }

        hd_print('UaKinoNet_Category_Video::getNextData $url = ' . $url);

        $agent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 1.0.3705; .NET CLR 1.1.4322)';

        $header[0] = "Accept: text/xml,application/xml,application/xhtml+xml,";
        $header[0] .= "text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5";
        $header[] = "Cache-Control: max-age=0";
        $header[] = "Connection: keep-alive";
        $header[] = "Keep-Alive: 300";
        $header[] = "Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7";
        $header[] = "Accept-Language:ru,en-US;q=0.8,en;q=0.6,pl;q=0.4";
        $header[] = "Pragma: "; // browsers keep this blank.

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_VERBOSE, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_USERAGENT, $agent);
        curl_setopt($ch, CURLOPT_URL, $url);
        $str = curl_exec($ch);

//        hd_print($str);
        preg_match_all($regexp, $str, $out);

        $items = array();
        if (isset($out[1][0]))
        {
            for ($i = 0; $i < count($out[1]); $i++)
            {
                $is_serial = trim(strip_tags($out[1][$i]));
                $image_path = strip_tags($out[3][$i]);

                if (strpos($image_path, 'http://') === FALSE)
                    $image_path = 'http://' . Rise::$config->load('uakinonet.host') . $image_path;


                $items [] = array(
                    'serial' => !empty($is_serial) ? true : false,
                    'link' => html_entity_decode(strip_tags($out[2][$i])),
                    'image' => $image_path,
                    'caption' => html_entity_decode(strip_tags($out[4][$i]))
                );
            }
        }

        return count($items) == 0 ? false : $items;
    }

    /**
     *
     * @return type 
     */
    public function getItemNoMore()
    {
        return array
            (
            PluginRegularFolderItem::caption => 'Больше ничего не найдено...',
            PluginRegularFolderItem::view_item_params => array
                (
                ViewItemParams::item_paint_icon => false,
                ViewItemParams::icon_path => 'gui_skin://large_icons/movie.aai',
                ViewItemParams::item_layout => HALIGN_LEFT,
                ViewItemParams::icon_valign => VALIGN_CENTER,
                ViewItemParams::item_detailed_icon_path => 'missing://',
            ),
            PluginRegularFolderItem::media_url => 'dummy'
        );
    }

}

?>
