<?php


class UaKinoNet_Category_Video_Search extends UaKinoNet_Category_Video 
{
    const ID = 'UaKinoNet_Category_Video_Search_ID';
    private $searh_text;
    
    function get_handler_id()
    {
        return self::ID;
    }
    
    function input(&$input)
    {
        hd_print("UaKinoNet_Category_Video_Search::input = ".  json_encode($input));
        
        if(isset($input->control_id))
        {
            $control_id = $input->control_id;
            switch ($control_id)
            {
                case 'UaKinoNet_Category_Video_Search->seach':

                    $new_value = $input->{$control_id};
                    
                    return array(
                        GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                        GuiAction::data => array(
                            PluginOpenFolderActionData::media_url => 'UaKinoNet_Category_Video_Search->seach_result/'. urlencode($new_value),
                            PluginOpenFolderActionData::caption => $new_value,
                        )
                    );
            }
        }
        
        return parent::input($input); // favorites functions.
    }
    
    /**
     *
     * @param type $searh_text
     * @param type $search_id
     * @return type 
     */
    function seach_result($searh_text = NULL, $search_id = 0)
    {
        $this->searh_text = urldecode($searh_text);
        Cookie::set('search_text', $this->searh_text);
        
        $n = Cookie::get('search_count', 0);
        if($n % 30 == 0)
        {
            // Deleting first searched 15 points.
            for($i = ($n - 15); $i >= ($n - 30); $i--)
                Cookie::delete('search_text'.$i);
        }    
        Cookie::set('search_count', ++$n);

        Cookie::set('search_text'.$n, $this->searh_text);
        
        hd_print("UaKinoNet_Category_Video_Search::seach_result \$searh_text = {$this->searh_text}");
        
        $this->page = 0;
        $this->data = array();
        
        $add_to_fav_action = UserInputHandlerRegistry::create_action($this, 'add_to_fav');
        $add_to_fav_action['caption'] = 'Добавить в избранное';
        
        $actions = array
            (
            GUI_EVENT_KEY_ENTER => self::$folder_open_action,
            GUI_EVENT_KEY_PLAY => self::$folder_open_action,
            GUI_EVENT_KEY_D_BLUE => $add_to_fav_action,
        );

        $style = Cookie::get('current_list_video_style', '0');
        
        switch ($style)
        {
            case 0:
                return DuneLists::build_text_list_with_reloading($this->getLoadingItems(), $actions);
            case 1:
                return DuneLists::build_img_with_details_list_with_reloading($this->getLoadingItems(), $actions);
            case 2:
                return DuneLists::build_img_list_with_reloading($this->getLoadingItems(), $actions);
            default:
                return DuneLists::build_text_list_with_reloading($this->getLoadingItems(), $actions);
                
        }
    }
    
    
    function seach_resultRegular($ndx = 0)
    {
        $this->searh_text = Cookie::get('search_text');
        hd_print('$this->searh_text = ' . $this->searh_text);
        $url = 'http://' . Rise::$config->load('uakinonet.host') . Rise::$config->load('uakinonet.start_page.search.link') . urlencode($this->searh_text);
        hd_print("UaKinoNet_Category_Video_Search::seach_resultRegular \$url = $url");
        
        $regexp = '{<a href="(\S*?)video/(\d*?)" class="fleft thumb"><img src="(.*?)".*?alt="(.*?)"}si';
        return $this->indexParrentRegular($url, $regexp, $ndx);
    }
    
    
    /**
     *
     * @return type 
     */
    function index($confing_path, $video_id = 0)
    {
        $defs = array();

        ControlFactory::add_vgap($defs, 50);
        ControlFactory::add_label($defs, "            ", "Введите часть названия фильма:");

        UserInputHandlerRegistry::create_action($this, 'do_search');
        
        $this->add_text_field($defs, 'UaKinoNet_Category_Video_Search->seach', "", Cookie::get('search_text'), 0, 0,  1, 0, 1550, true, 0);
        $folder_view = array(
            PluginControlsFolderView::defs => $defs,
            PluginControlsFolderView::initial_sel_ndx => - 1,
        );

        return array(
            PluginFolderView::multiple_views_supported => false,
            PluginFolderView::archive => null,
            PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_CONTROLS,
            PluginFolderView::data => $folder_view,
        );
    }
    
    
    function getVideoInfo($video_id)
    {
        $currnet_confing_path = Cookie::get('currnet_confing_path');

        hd_print("UaKinoNet_Category_Video::getVideoInfo \$currnet_confing_path = $currnet_confing_path");

        $v = Rise::$config->load($currnet_confing_path . '.details_link');
        $detail_link = empty($v) ? Rise::$config->load('uakinonet.default_detail_link') : $v;

        $url = $this->video_details_url = 'http://' . Rise::$config->load('uakinonet.host') . $detail_link . $video_id;

        hd_print('UaKinoNet_Category_Video->getVideoInfo url= ' . $url);
        try
        {
            $content = file_get_contents($url);
//            hd_print($content);
        } catch (Exception $e)
        {
            hd_print($e->getMessage());
        }

     //   preg_match_all('{var flvfile = "(.*?)".*?poster: "(.*?)"}si', $content, $m_file);
		preg_match('{var flvfile = \'(.*?)\';}si', $content, $m_file);
		preg_match('{poster: "(.*?)"}si', $content, $p_file);
		preg_match('{ролях:</span>(.*?)</li>}si', $content, $m_actors);        
        preg_match('{Название:</span>(.*?)</li>}si', $content, $m_title1);
        preg_match('{Год выхода:</span>(.*?)</li>}si', $content, $m_year);
        preg_match('{Жанр:</span>(.*?)</li>}si', $content, $m_genre);
        preg_match('{<div id="media_description">(.*?)</span>}si', $content, $m_descr);
        preg_match('{Страна:</span>(.*?)</li>}si', $content, $m_country);
        preg_match('{Режиссер:</span>(.*?)</li>}si', $content, $m_directors);
        preg_match_all('{<span>Оригинальное название:</span>(.*?)</i>}si', $content, $m_title_native);
        
        if (isset($m_file[1][0]))
        {
            $videoInfo = array(
                'id' => $video_id,
                'title' => trim(strip_tags($m_title1[1])) . ' / '. trim(strip_tags($m_title_native[1][0])),
                'image' => trim(strip_tags($p_file[1])),
                'genre' => trim(strip_tags($m_genre[1])),
                'year' => trim(strip_tags($m_year[1])),
                'country' => trim(strip_tags($m_country[1])),
                'directors' => trim(strip_tags($m_directors[1])),
                'actors' => trim(strip_tags($m_actors[1])),
                'description' => trim(strip_tags($m_descr[1])),
                'file' => 'http://uakino.net/play.php?mid=' . $video_id .'.mp4',
            );
        } else
        {
            hd_print('No video info found');

            $videoInfo = array(
                'id' => $video_id,
                'title' => '',
                'image' => '',
                'genre' => '',
                'year' => '',
                'country' => '',
                'actors' => '',
                'description' => '',
                'file' => '',
            );
        }
        
        $this->video = $videoInfo;
        return $videoInfo;
    }    

    /**
     *
     * @param type $defs
     * @param type $name
     * @param type $title
     * @param type $initial_value
     * @param type $numeric
     * @param type $password
     * @param type $has_osk
     * @param type $always_active
     * @param type $width
     * @param type $need_confirm
     * @param type $need_apply 
     */
    public function add_text_field(&$defs, $name, $title, $initial_value, $numeric, $password, $has_osk, $always_active, $width, $need_confirm = false, $need_apply = false)
    {
        ControlFactory::add_text_field($defs, $this, null, $name, $title, $initial_value, $numeric, $password, $has_osk, $always_active, $width, $need_confirm, $need_apply);
    }
}



