<?php

/**
 */
class Plugin extends TangoDunePlugin
{
    /**
     *
     * @param type $input
     * @param type $plugin_cookies
     * @return type 
     */
    public function handle_user_input(&$input, &$plugin_cookies)
    {
        Cookie::init($plugin_cookies);

        // Calling for it, is very impotant for auto upgrading.
        $result = parent::handle_user_input($input, $plugin_cookies);
        if ($result) return $result;
        
        return Screen::call_input($input);
    }

    /**
     *
     * @param type $media_url
     * @param type $plugin_cookies
     * @return type 
     */
    public function get_folder_view($media_url, &$plugin_cookies)
    {
        Cookie::init($plugin_cookies);
        hd_print('get_folder_view => ' . $media_url);
        return Screen::view($media_url);
    }

    /**
     *
     * @param type $media_url
     * @param type $from_ndx
     * @param type $plugin_cookies
     * @return type 
     */
    public function get_regular_folder_items($media_url, $from_ndx, &$plugin_cookies)
    {
        Cookie::init($plugin_cookies);
        hd_print('get_regular_folder_items => ' . $media_url);
        return Screen::viewRegular($media_url, $from_ndx);
    }

    /**
     * Start video
     * @param type $media_url
     * @param type $plugin_cookies
     * @return type 
     */
    public function get_vod_info($media_url, &$plugin_cookies)
    {
        Cookie::init($plugin_cookies);
        preg_match_all('/(.*)->.*?\/(.*)/', $media_url, $matches);

        $movie_class = new $matches[1][0];
        $movie = $movie_class->getVideoInfo($matches[2][0]);

        hd_print("get_vod_info \$movie = " . json_encode($movie));

        $linkToVideo = $movie['file'];
        hd_print('Plugin url = ' . $linkToVideo);

        $video_url = Url::prepareVideoUrl($linkToVideo);
        hd_print('Plugin url prepared $video_url = ' . $video_url);

        $buffer_ms = Cookie::get('buffer_ms', 0);
        hd_print('Plugin $buffer_ms = ' . ($buffer_ms*1000));
        
        return array
            (
            PluginVodInfo::name => $movie['title'],
            PluginVodInfo::description => $movie['description'],
            PluginVodInfo::poster_url => $movie['image'],
            PluginVodInfo::initial_series_ndx => 0,
            PluginVodInfo::series => array
                (
                array
                    (
                    PluginVodSeriesInfo::name => 'Video',
                    PluginVodSeriesInfo::playback_url => $video_url,
                    PluginVodSeriesInfo::playback_url_is_stream_url => true
                )
            ),
            PluginVodInfo::buffering_ms => ($buffer_ms * 1000),
            PluginVodInfo::ip_address_required => TRUE,
            PluginVodInfo::valid_time_required => FALSE,
        );
    }

    /**
     * Changing view.
     * @param type $media_url
     * @param type $plugin_cookies
     * @return type 
     */
    function get_next_folder_view($media_url, &$plugin_cookies)
    {
        Cookie::init($plugin_cookies);
        preg_match_all('/(.*)->.*?\/(.*)/', $media_url, $matches);

        hd_print(json_encode($matches));

        $node = empty($matches[2][0]) ? 'uakinonet.start_page' : $matches[2][0] . '.childs';

        //  kind of configuration.
        $node = str_replace('start_page.catalog.childs', 'categories', $node);

        hd_print("\$node = $node");

        $style = Cookie::get('current_list_style', 'image');

        hd_print("Plugin get_next_folder_view \$media_url = $media_url, \$style = $style, \$node = $node ");

        if ($style != 'image')
        {
            $items = Screen::build_category($node);
        } else
        {
            $items = Screen::build_category_with_image($node);
        }

        if (count($items) > 0)
        {
            if ($style != 'image')
            {
                Cookie::set('current_list_style', 'image');
            } 
            else
            {
                Cookie::set('current_list_style', 'text');
            }
        } 
        else
        {
            $style = Cookie::get('current_list_video_style', '0');
            
            $style = is_numeric($style) && $style < 2 ? ++$style : 0;
            
            Cookie::set('current_list_video_style',  $style);
        }
        
        return $this->get_folder_view($media_url, $plugin_cookies);
    }

}

?>
